'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Badge = (function (_React$Component) {
  _inherits(Badge, _React$Component);

  function Badge() {
    _classCallCheck(this, Badge);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Badge).apply(this, arguments));
  }

  _createClass(Badge, [{
    key: 'render',
    value: function render() {
      var $props = this.props;

      // CSS classes
      var context = {
        success: 'uk-badge-' + $props.context,
        warning: 'uk-badge-' + $props.context,
        danger: 'uk-badge-' + $props.context
      };

      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses(['uk-badge', $props.classes, context[$props.context] || null, $props.notification ? 'uk-badge-notification' : null, $props.className]);

      // Elements
      var block = _react2.default.createElement(
        'div',
        _extends({}, $props, {
          className: cssClassNames,
          'data-kitid': $props.kitid
        }),
        $props.body,
        $props.children
      );

      var inline = _react2.default.createElement(
        'span',
        _extends({}, $props, {
          className: cssClassNames,
          'data-kitid': $props.kitid
        }),
        $props.body,
        $props.children
      );

      // Return Component
      var component = _ufunc2.default.either(block, inline);
      return component($props.block);
    }
  }]);

  return Badge;
})(_react2.default.Component);

Badge.propTypes = {
  context: _react2.default.PropTypes.oneOf(['success', 'warning', 'danger']),
  block: _react2.default.PropTypes.bool,
  body: _react2.default.PropTypes.string,
  notification: _react2.default.PropTypes.bool
};
exports.default = _reactUikitBase2.default.base(Badge);